diff --git a/sources/pyside2/libpyside/signalmanager.cpp b/sources/pyside2/libpyside/signalmanager.cpp
index c21a3e56..f61e5208 100644
--- a/sources/pyside2/libpyside/signalmanager.cpp
+++ b/sources/pyside2/libpyside/signalmanager.cpp
@@ -54,12 +54,14 @@
 #include <sbkconverter.h>
 #include <sbkstring.h>
 #include <sbkstaticstrings.h>
+#include <helper.h>
 
 #include <QtCore/QDebug>
 #include <QtCore/QHash>
 
 #include <algorithm>
 #include <limits>
+#include <iostream>
 
 // These private headers are needed to throw JavaScript exceptions
 #if PYSIDE_QML_PRIVATE_API_SUPPORT
@@ -509,25 +511,31 @@ int SignalManager::callPythonMetaMethod(const QMetaMethod &method, void **args,
 
     Shiboken::GilState gil;
     PyObject *pyArguments = nullptr;
+    std::cerr << '>' << __FUNCTION__ << " method.name=\"" << method.name().constData()
+              << "\" " << Shiboken::debugPyObject(pyMethod) << " isShortCuit=" << isShortCuit << '\n';
 
     if (isShortCuit){
         pyArguments = reinterpret_cast<PyObject *>(args[1]);
     } else {
         pyArguments = parseArguments(method.parameterTypes(), args);
     }
+    std::cerr << ' ' << __FUNCTION__ << " pyArguments=" <<  Shiboken::debugPyObject(pyArguments) <<  '\n';
 
     if (pyArguments) {
         Shiboken::Conversions::SpecificConverter *retConverter = nullptr;
         const char *returnType = method.typeName();
         if (returnType && std::strcmp("", returnType) && std::strcmp("void", returnType)) {
             retConverter = new Shiboken::Conversions::SpecificConverter(returnType);
+            std::cerr << __FUNCTION__ << " retConverter=" << retConverter  << ' ' << returnType << '\n' ;
             if (!retConverter || !*retConverter) {
                 PyErr_Format(PyExc_RuntimeError, "Can't find converter for '%s' to call Python meta method.", returnType);
                 return -1;
             }
         }
 
+        std::cerr << ' ' << __FUNCTION__ << " >PyObject_CallObject\n";
         Shiboken::AutoDecRef retval(PyObject_CallObject(pyMethod, pyArguments));
+        std::cerr << ' ' << __FUNCTION__ << " <PyObject_CallObject\n";
 
         if (!isShortCuit && pyArguments){
             Py_DECREF(pyArguments);
@@ -539,6 +547,8 @@ int SignalManager::callPythonMetaMethod(const QMetaMethod &method, void **args,
         delete retConverter;
     }
 
+    std::cerr << '<' << __FUNCTION__ << " \"" << method.name().constData() << "\"\n";
+
     return -1;
 }
 
@@ -645,6 +655,7 @@ static PyObject *parseArguments(const QList<QByteArray>& paramTypes, void **args
     for (int i = 0, max = argsSize; i < max; ++i) {
         void *data = args[i+1];
         const char *dataType = paramTypes[i].constData();
+        std::cerr <<  ' ' << __FUNCTION__ << " paramTypes[" << i << '/' << max << "]=" << dataType << '\n';
         Shiboken::Conversions::SpecificConverter converter(dataType);
         if (converter) {
             PyTuple_SET_ITEM(preparedArgs, i, converter.toPython(data));
--- testenv5153d_build/py3.7-qt5.15.0-64bit-debug/pyside2/PySide2/QtCore/PySide2/QtCore/qobject_wrapper.cpp.orig	2020-02-27 14:34:02.504469186 +0100
+++ testenv5153d_build/py3.7-qt5.15.0-64bit-debug/pyside2/PySide2/QtCore/PySide2/QtCore/qobject_wrapper.cpp	2020-02-27 14:39:10.329567236 +0100
@@ -51,6 +51,8 @@
 #include <pyside.h>
 #include <destroylistener.h>
 #include <qapp_macro.h>
+#include <helper.h>
+#include <iostream>
 
 QT_WARNING_DISABLE_DEPRECATED
 
@@ -1756,6 +1758,7 @@
 
 static PyObject *Sbk_QObjectFunc_emit(PyObject *self, PyObject *args)
 {
+    std::cerr << __FUNCTION__ << ' ' << Shiboken::debugPyObject(self) << ',' << Shiboken::debugPyObject(args) << '\n';
     ::QObject *cppSelf = nullptr;
     SBK_UNUSED(cppSelf)
     if (!Shiboken::Object::isValid(self))
@@ -1779,7 +1782,7 @@
 
     if (!PyArg_UnpackTuple(nonvarargs, "emit", 1, 1, &(pyArgs[0])))
         return {};
-
+    std::cerr << __FUNCTION__ << " pyArgs[]=" << Shiboken::debugPyObject(pyArgs[0]) << ',' << Shiboken::debugPyObject(pyArgs[1]) << '\n';
 
     // Overloaded function decisor
     // 0: QObject::emit(const char*,...)