diff --git a/src/gui/kernel/qguiapplication.cpp b/src/gui/kernel/qguiapplication.cpp
index a0ab112c8e..37d8366f76 100644
--- a/src/gui/kernel/qguiapplication.cpp
+++ b/src/gui/kernel/qguiapplication.cpp
@@ -3056,7 +3056,10 @@ void QGuiApplicationPrivate::processScreenGeometryChange(QWindowSystemInterfaceP
     bool availableGeometryChanged = e->availableGeometry != s->d_func()->availableGeometry;
     s->d_func()->availableGeometry = e->availableGeometry;
 
+    qDebug() << __FUNCTION__ << '>' << s << e->geometry << e->availableGeometry;
+
     if (geometryChanged) {
+        qDebug() << __FUNCTION__ << "geometryChanged branch";
         Qt::ScreenOrientation primaryOrientation = s->primaryOrientation();
         s->d_func()->updatePrimaryOrientation();
 
@@ -3071,6 +3074,8 @@ void QGuiApplicationPrivate::processScreenGeometryChange(QWindowSystemInterfaceP
 
     s->d_func()->emitGeometryChangeSignals(geometryChanged, availableGeometryChanged);
 
+    qDebug() << __FUNCTION__ << '<';
+
     resetCachedDevicePixelRatio();
 }
 
@@ -3087,10 +3092,12 @@ void QGuiApplicationPrivate::processScreenLogicalDotsPerInchChange(QWindowSystem
 
     QScreen *s = e->screen.data();
     s->d_func()->logicalDpi = QDpi(e->dpiX, e->dpiY);
+    qDebug() << __FUNCTION__ << '>' << s << e->dpiX;
 
     emit s->logicalDotsPerInchChanged(s->logicalDotsPerInch());
     s->d_func()->updateGeometriesWithSignals();
 
+    qDebug() << __FUNCTION__ << '<';
     resetCachedDevicePixelRatio();
 }
 
diff --git a/src/gui/kernel/qscreen.cpp b/src/gui/kernel/qscreen.cpp
index 7cc88af302..526252e513 100644
--- a/src/gui/kernel/qscreen.cpp
+++ b/src/gui/kernel/qscreen.cpp
@@ -81,12 +81,15 @@ void QScreenPrivate::updateGeometriesWithSignals()
 {
     const QRect oldGeometry = geometry;
     const QRect oldAvailableGeometry = availableGeometry;
+    qDebug() << __FUNCTION__ << oldGeometry << '>' << geometry
+             << oldAvailableGeometry  << '>' <<  availableGeometry;
     updateHighDpi();
     emitGeometryChangeSignals(oldGeometry != geometry, oldAvailableGeometry != availableGeometry);
 }
 
 void QScreenPrivate::emitGeometryChangeSignals(bool geometryChanged, bool availableGeometryChanged)
 {
+    qDebug() << __FUNCTION__ << '>' << geometryChanged<< availableGeometryChanged;
     Q_Q(QScreen);
     if (availableGeometryChanged)
         emit q->availableGeometryChanged(availableGeometry);
@@ -96,6 +99,7 @@ void QScreenPrivate::emitGeometryChangeSignals(bool geometryChanged, bool availa
         for (QScreen* sibling : siblings)
             emit sibling->virtualGeometryChanged(sibling->virtualGeometry());
     }
+    qDebug() << __FUNCTION__ << '<';
 }
 
 void QScreenPrivate::setPlatformScreen(QPlatformScreen *screen)
@@ -103,6 +107,7 @@ void QScreenPrivate::setPlatformScreen(QPlatformScreen *screen)
     Q_Q(QScreen);
     platformScreen = screen;
     platformScreen->d_func()->screen = q;
+    qDebug() << __FUNCTION__ << q;
     orientation = platformScreen->orientation();
 
     logicalDpi = QPlatformScreen::overrideDpi(platformScreen->logicalDpi());
diff --git a/src/gui/kernel/qwindowsysteminterface.cpp b/src/gui/kernel/qwindowsysteminterface.cpp
index 7da812f64d..0e26210683 100644
--- a/src/gui/kernel/qwindowsysteminterface.cpp
+++ b/src/gui/kernel/qwindowsysteminterface.cpp
@@ -825,12 +825,14 @@ void QWindowSystemInterface::handleScreenGeometryChange(QScreen *screen, const Q
 {
     QWindowSystemInterfacePrivate::ScreenGeometryEvent *e =
         new QWindowSystemInterfacePrivate::ScreenGeometryEvent(screen, QHighDpi::fromNativeScreenGeometry(geometry, screen), QHighDpi::fromNative(availableGeometry, screen, geometry.topLeft()));
+    qDebug() << __FUNCTION__ << screen << geometry << availableGeometry;
     QWindowSystemInterfacePrivate::handleWindowSystemEvent(e);
 }
 
 void QWindowSystemInterface::handleScreenLogicalDotsPerInchChange(QScreen *screen, qreal dpiX, qreal dpiY)
 {
     const QDpi effectiveDpi = QPlatformScreen::overrideDpi(QDpi{dpiX, dpiY});
+    qDebug() << __FUNCTION__ << screen << dpiX;
     auto e = new QWindowSystemInterfacePrivate::ScreenLogicalDotsPerInchEvent(screen, effectiveDpi.first, effectiveDpi.second);
     QWindowSystemInterfacePrivate::handleWindowSystemEvent(e);
 }